VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1695
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2175
   LinkTopic       =   "Form1"
   ScaleHeight     =   1695
   ScaleWidth      =   2175
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtValue 
      Height          =   285
      Left            =   720
      TabIndex        =   1
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label lblLong 
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   1320
      Width           =   1695
   End
   Begin VB.Label lblInteger 
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   960
      Width           =   1695
   End
   Begin VB.Label lblByte 
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   600
      Width           =   1695
   End
   Begin VB.Label Label1 
      Caption         =   "Value"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Return True if the value is a valid Byte string
' (decimal not hex).
Public Function IsAByte(ByVal txt As String) As Boolean
Dim test_byte As Byte

    On Error Resume Next
    txt = TrimmedNumber(txt)
    test_byte = CByte(txt)

    If Err <> 0 Then
        IsAByte = False
    Else
        IsAByte = (CStr(test_byte) = txt)
    End If
End Function
' Return True if the value is a valid Integer string.
Public Function IsAnInteger(ByVal txt As String) As Boolean
Dim test_integer As Integer

    On Error Resume Next
    txt = TrimmedNumber(txt)
    test_integer = CInt(txt)

    If Err <> 0 Then
        IsAnInteger = False
    Else
        IsAnInteger = (CStr(test_integer) = txt)
    End If
End Function
' Return True if the value is a valid Long string.
Public Function IsALong(ByVal txt As String) As Boolean
Dim test_long As Long

    On Error Resume Next
    txt = TrimmedNumber(txt)
    test_long = CLng(txt)

    If Err <> 0 Then
        IsALong = False
    Else
        IsALong = (CStr(test_long) = txt)
    End If
End Function

' Remove leading spaces, possibly on both sides of
' a "-" or "+" sign. Examples:
'       "  - 12 2"      -->     "-12 2"
'       " X 12"         -->     "X12"
Private Function TrimmedNumber(ByVal txt As String) As String
Dim trimmed_txt As String
Dim i As Integer
Dim ch As String

    txt = Trim$(txt)
    For i = 1 To Len(txt)
        ch = Mid$(txt, i, 1)
        If ch = " " Then
            ' Skip this space.
        ElseIf (ch >= "0") And (ch >= "0") Then
            ' This is the first digit.
            ' Copy the rest of the text.
            trimmed_txt = trimmed_txt & Mid$(txt, i)
            Exit For
        Else
            ' This is something else. Possibly a "-"
            ' or a "+", or garbage. Keep it.
            trimmed_txt = trimmed_txt & ch
        End If
    Next i

    TrimmedNumber = trimmed_txt
End Function

Private Sub Form_Load()
    txtValue.Text = "  - 123"
End Sub


Private Sub txtValue_Change()
    If IsAByte(txtValue.Text) Then
        lblByte.Caption = "Byte"
    Else
        lblByte.Caption = "Not a Byte"
    End If
    If IsAnInteger(txtValue.Text) Then
        lblInteger.Caption = "Integer"
    Else
        lblInteger.Caption = "Not an Integer"
    End If
    If IsALong(txtValue.Text) Then
        lblLong.Caption = "Long"
    Else
        lblLong.Caption = "Not a Long"
    End If
End Sub


